"""Initial migration

Revision ID: 176b845f3f94
Revises: 
Create Date: 2025-02-19 21:41:19.163980

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '176b845f3f94'
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('screenshots',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('file_path', sa.String(), nullable=True),
    sa.Column('timestamp', sa.DateTime(), nullable=True),
    sa.Column('app_name', sa.String(), nullable=True),
    sa.Column('window_title', sa.String(), nullable=True),
    sa.Column('extracted_text', sa.Text(), nullable=True),
    sa.Column('confidence_score', sa.Float(), nullable=True),
    sa.Column('is_favorite', sa.Boolean(), nullable=True),
    sa.Column('notes', sa.Text(), nullable=True),
    sa.Column('summary', sa.Text(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_screenshots_app_name'), 'screenshots', ['app_name'], unique=False)
    op.create_index(op.f('ix_screenshots_file_path'), 'screenshots', ['file_path'], unique=True)
    op.create_index(op.f('ix_screenshots_id'), 'screenshots', ['id'], unique=False)
    op.create_index(op.f('ix_screenshots_timestamp'), 'screenshots', ['timestamp'], unique=False)
    op.create_table('tags',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('is_auto_generated', sa.Boolean(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tags_id'), 'tags', ['id'], unique=False)
    op.create_index(op.f('ix_tags_name'), 'tags', ['name'], unique=True)
    op.create_table('screenshot_tags',
    sa.Column('screenshot_id', sa.Integer(), nullable=False),
    sa.Column('tag_id', sa.Integer(), nullable=False),
    sa.Column('tagged_at', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['screenshot_id'], ['screenshots.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['tag_id'], ['tags.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('screenshot_id', 'tag_id')
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('screenshot_tags')
    op.drop_index(op.f('ix_tags_name'), table_name='tags')
    op.drop_index(op.f('ix_tags_id'), table_name='tags')
    op.drop_table('tags')
    op.drop_index(op.f('ix_screenshots_timestamp'), table_name='screenshots')
    op.drop_index(op.f('ix_screenshots_id'), table_name='screenshots')
    op.drop_index(op.f('ix_screenshots_file_path'), table_name='screenshots')
    op.drop_index(op.f('ix_screenshots_app_name'), table_name='screenshots')
    op.drop_table('screenshots')
    # ### end Alembic commands ###
